<template>
  <v-container>
    <v-card>
      <v-card-title>
        Create User
      </v-card-title>
      <v-container>
        <validation-observer
          ref="observer"
          v-slot="{ invalid }"
        >
          <v-form
            @submit.prevent="submit"
            ref='form'
          >
            <form-field
              v-for="field in fields"
              :key="field.id"
              :data='user'
              :field="field"
            />
            <v-card-actions>
              <v-spacer />
              <v-btn
                type="submit"
                :disabled="invalid"
              >
                Create
              </v-btn>
            </v-card-actions>
          </v-form>
        </validation-observer>
      </v-container>
    </v-card>
  </v-container>
</template>

<script lang="ts">
import Vue from 'vue'
import { fields } from '@/util/user-fields'
import FormField from '@/components/FormField.vue'
import { post } from '../util/http'

export default Vue.extend({
  name: 'create-user-page',
  components: { FormField },
  data () {
    return {
      fields,
      user: {} as { [key: string]: string }
    }
  },
  mounted () {
    this.clear()
  },
  methods: {
    clear () {
      const user: { [key: string]: string } = {}

      fields.forEach((field) => {
        this.user[field.id] = ''
      })

      this.user = user
    },
    async submit () {
      // eslint-disable-next-line @typescript-eslint/no-explicit-any
      if (!(this.$refs.form as any).validate()) { return }

      try {
        if ((await post('user', { create: this.user })).data.status === 'ERROR') {
          throw new Error('Failed')
        }

        this.clear()
      } catch (e) {
        alert(e.msg)
      }
    }
  }
})
</script>
